<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 																   *
 * 			Fichier 		:	functions.session.php			   *
 * 			Cr le 		:	21 octobre 2002					   *
 * 			Dernire modif 	:	24 octobre 2002					   *
 * 			Email			: 	wascripts@phpcodeur.net			   *
 * 			 Copyright 2002 PHPcodeur							   *
 * 							  									   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *																   *
 *  This program is free software; you can redistribute it and/or  *
 * 	modify it under the terms of the GNU General Public License as *
 * 	published by the Free Software Foundation; either version 2 of *
 *  the License, or (at your option) any later version.			   *
 * 																   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


//////////////////////////////////////////////////////////////
//
// Fonctions utilises pour les sessions sur l'administration.
//

//
// Ouverture d'une session.
//
// session_open prend l'identifiant de l'utilisateur comme argument.
//
function session_open($admin_id)
{
	global $newsletter_config, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid, $db;
	
	$method = isset($HTTP_COOKIE_VARS['wanewsletter_test']) ? 'COOKIE' : 'GET';
	
	$sql = "SELECT * 
			FROM " . ADMIN_TABLE . " 
			WHERE admin_id = '$admin_id'";
	if( !($result = $db->query($sql)) )
	{
		message(GENERAL_ERROR, 'Impossible d\'obtenir des informations sur l\'utilisateur', __FILE__, __LINE__, $sql);
	}
	
	$admindata = $db->fetch_array($result);
	$starttime = time();
	$session_id = md5(uniqid($admindata['user']));
	
	$sql = "UPDATE " . SESSION_TABLE . " 
			SET session_id = '$session_id', 
			    session_start = '$starttime', 
				session_time = '$starttime' 
			WHERE admin_id = '$admin_id'";	
	if( !($result = $db->query($sql)) )
	{
		message(GENERAL_ERROR, 'Impossible de mettre  jour la session', __FILE__, __LINE__, $sql);
	}
	
	if( !$db->affected_rows() )
	{	
		$sql = "INSERT INTO " . SESSION_TABLE . " (session_id, admin_id, session_start, session_time) 
				VALUES('$session_id','$admin_id','$starttime','$starttime')";	
		if( !($result = $db->query($sql)) )
		{
			message(GENERAL_ERROR, 'Impossible de dmarrer la session', __FILE__, __LINE__, $sql);
		}
	}	
	
	if( $method == 'COOKIE' )
	{		
		setcookie("wanewsletter_test", "1", time() - 99999, "/");
		setcookie("wanewsletter_sessid", $session_id, time() + 99999, "/");
	}
	else if( $method == 'GET' )
	{
		$sid = 'sessid=' . $session_id;
	}
	
	return $admindata;
}

//
// Vrification de l'existence d'une session grce  l'identifiant de session
// obtenu par dfaut via le cookie, ou, si les cookies ne sont pas accepts par le navigateur, 
// via l'url.
//
function session_verif()
{
	global $newsletter_config, $lang, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid, $db;
	
	if( isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) )
	{
		$session_id = isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) ? $HTTP_COOKIE_VARS['wanewsletter_sessid'] : '';
		$method = 'COOKIE';
	}
	else if( isset($HTTP_GET_VARS['sessid']) )
	{
		$session_id = isset($HTTP_GET_VARS['sessid']) ? $HTTP_GET_VARS['sessid'] : '';
		$method = 'GET';
	}
	else
	{
		return false;
	}
	
	$time = time();
	
	$sql = "UPDATE " . SESSION_TABLE . " 
			SET session_time = '$time' 
			WHERE session_id = '$session_id'";
	if( !($result = $db->query($sql)) )
	{
		message(GENERAL_ERROR, 'Impossible de mettre  jour la session', __FILE__, __LINE__, $sql);
	}
	
	$sql = "SELECT a.admin_id, a.user, a.passwd, a.email, a.level, s.session_id, s.admin_id, s.session_start, s.session_time 
			FROM " . ADMIN_TABLE . " AS a, " . SESSION_TABLE . " AS s 
			WHERE a.admin_id = s.admin_id AND s.session_id = '$session_id'";	
	if( !($result = $db->query($sql)) )
	{
		$msg = 'Impossible d\'obtenir des informations sur la session et sur l\'utilisateur';
		message(GENERAL_ERROR, $msg, __FILE__, __LINE__, $sql);
	}
	
	if( !($db->num_rows($result)) )
	{
		return false;
	}
	
	$admindata = $db->fetch_array($result);
	$db->free_result($result);
	
	$intervalle = $admindata['session_time'] - $admindata['session_start'];
	
	if( $intervalle > $newsletter_config['session_duree'] )
	{
		$sql = "DELETE FROM " . SESSION_TABLE . " 
				WHERE session_id = '$session_id'";
		if( !($result = $db->query($sql)) )
		{
			$msg = 'Impossible de clotrer la session';
			message(GENERAL_ERROR, $msg, __FILE__, __LINE__, $sql);
		}
		
		return false;
	}
	
	if( $method == 'GET' )
	{
		$sid = 'sessid=' . $session_id;
	}
	
	return $admindata;
}

//
// Fermeture de la session en cours.
//
function session_close()
{
	global $newsletter_config, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid, $db;
	
	if( isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) )
	{
		$session_id = isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) ? $HTTP_COOKIE_VARS['wanewsletter_sessid'] : '';
		setcookie("wanewsletter_sessid", "", time() - 99999, "/");
		$method = 'COOKIE';
	}
	else
	{
		$session_id = isset($HTTP_GET_VARS['sessid']) ? $HTTP_GET_VARS['sessid'] : '';
		$method = 'GET';
	}
	
	$sql = "DELETE FROM " . SESSION_TABLE . " 
			WHERE session_id = '$session_id'";
	if( !($result = $db->query($sql)) )
	{
		$msg = 'Impossible de clotrer la session';
		message(GENERAL_ERROR, $msg, __FILE__, __LINE__, $sql);
	}
}

//
// Ajout de l'identifiant de session s'il est transmis par l'url.
//
function sessid($url)
{
	global $sid;
	
	if ( $sid != '' && !ereg('sessid=', $url) )
	{
		$url .= ( ( strpos($url, '?') ) ?  '&' : '?' ) . $sid;
	}

	return($url);
}

//
// Fin des fonctions de session.
//
//////////////////////////////////////////////////////////////
?>